import tml,dialog,misc
from flags import *

# Mission1 Escort transport to Ixis star system

def escort_transport_to_ixis_func():
    gflag.current_mission = """ You must escort our transport to Ixis minning station."""
    gflag.m1_status = MISSION_IN_PROGRESS
    
    gflag.m1_transport = tml.GameAction.add_ship('Ixis',"choex", 3000, 3500, tml.GameAction.get_player_team())
    
    tml.GameAction.go_to_location(gflag.m1_transport, gflag.ixis_mining_station, 50)
    tml.EventManager.distanceLessThen(gflag.m1_transport, gflag.ixis_mining_station, 100,
                                      'escort_transport_to_ixis_mission_complete')
    tml.EventManager.distanceLessThen(gflag.m1_transport, tml.GameAction.get_player_ship_id(),
                                      5000,  'escort_transport_to_ixis_ask_help_against_kohr_ah')
    tml.EventManager.shipDeathById(gflag.m1_transport,'escort_transport_death')
    gflag.m1_enemy = tml.GameAction.add_ship('Ixis', "kzedr", 4000, 4000, tml.GameAction.get_enemy_team())
    tml.GameAction.set_crew(gflag.m1_enemy, 10)
    tml.GameAction.set_target(gflag.m1_enemy, gflag.m1_transport)
    tml.EventManager.shipDeathById(gflag.m1_enemy,'escort_transport_enemy_death')
    tml.GameAction.print_message("HINT: use 'M' key to access star map", 15)

def escort_transport_death():
    if gflag.m1_status != MISSION_COMPLETED:
        gflag.m1_status = MISSION_FAILED
        print "Mission 1 failed"

def escort_transport_enemy_death():
    tml.GameAction.set_camera_mode('Hero')
    
def escort_transport_to_ixis_ask_help_against_kohr_ah():
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/transport_please_help.xml"))
    tml.GameAction.set_target(tml.GameAction.get_player_ship_id(), gflag.m1_enemy)
    tml.GameAction.set_camera_mode('Enemy')
    
def escort_transport_to_ixis_mission_complete():
    gflag.m1_status = MISSION_COMPLETED
    tml.GameAction.remove_location(gflag.m1_transport)
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/transport_thanks.xml"))
    print "Mission 1 completed"
    
############################################################################################################
# Mission 2
def negotiate_with_chorali_func():
    gflag.m2_status = MISSION_IN_PROGRESS
    gflag.current_mission = """ You must negotiate with the Chorali at Ixis 5000, 5000."""
    
############################################################################################################
# Mission 3
def check_precursor_wreck_func():
    gflag.m3_status = MISSION_IN_PROGRESS
    gflag.current_mission = """ You must investigate precursor wrack in Ixis star system."""
    tml.EventManager.distanceLessThen(gflag.precursor_wreck_id,
                                  tml.GameAction.get_player_ship_id(),
                                  200,  'check_precursor_wreck_completed_func')

def check_precursor_wreck_completed_func():
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/precursor_wrack_first_inspection.xml"))
    gflag.m3_status = MISSION_COMPLETED

############################################################################################################
# Mission 4
def zoq_fot_pik_ambassador_func():
    gflag.current_mission = """ You must escort Zoq-Fot-Pik ambassador."""
    gflag.m4_status = MISSION_IN_PROGRESS
    tml.EventManager.jumpToSystem('Gama Onyx', 'zoq_fot_pik_ambassador_jump_to_gama_onyx')

def zoq_fot_pik_ambassador_jump_to_gama_onyx():
    gflag.m4_ambasador = tml.GameAction.add_ship('Gama Onyx',"zfpst",
                                                 tml.GameAction.get_location_pos_x(tml.GameAction.get_player_ship_id())+50,
                                                 tml.GameAction.get_location_pos_y(tml.GameAction.get_player_ship_id())+50,
                                                 tml.GameAction.get_player_team())
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/zoq-fot-pik.xml"))
    tml.GameAction.guard_location(gflag.m4_ambasador, tml.GameAction.get_player_ship_id(), 300)
    tml.GameAction.set_crew(gflag.m4_ambasador, 1)
    tml.EventManager.shipDeathById(gflag.m4_ambasador,'zoq_fot_pik_ambassador_death')
    tml.EventManager.distanceLessThen(gflag.m4_ambasador,
                                      gflag.gamaonyx_drax_station,
                                      600,  'drax_terrorist_attack')
    gflag.m4_status = MISSION_COMPLETED

def zoq_fot_pik_ambassador_death():
    if gflag.m4_status == MISSION_COMPLETED:
        return
    if tml.GameAction.exist(gflag.m4_terrorist1) or tml.GameAction.exist(gflag.m4_terrorist2):
        return
    gflag.m4_status == MISSION_FAILED
    
def drax_terrorist_attack():
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/drax_terr.xml"))
    gflag.m4_terrorist1 = tml.GameAction.add_ship('Gama Onyx', "dragr",
                                                  tml.GameAction.get_location_pos_x(gflag.gamaonyx_drax_station),
                                                  tml.GameAction.get_location_pos_y(gflag.gamaonyx_drax_station)+25,
                                                  tml.GameAction.get_enemy_team())

    gflag.m4_terrorist2 = tml.GameAction.add_ship('Gama Onyx', "dragr",
                                                  tml.GameAction.get_location_pos_x(gflag.gamaonyx_drax_station),
                                                  tml.GameAction.get_location_pos_y(gflag.gamaonyx_drax_station)-25,
                                                  tml.GameAction.get_enemy_team())
    tml.EventManager.shipDeathById(gflag.m4_terrorist1,'zoq_fot_pik_ambassador_terrorist_death')
    tml.EventManager.shipDeathById(gflag.m4_terrorist2,'zoq_fot_pik_ambassador_terrorist_death')
    tml.GameAction.set_target(gflag.m4_terrorist1, gflag.m4_ambasador)
    tml.GameAction.set_target(gflag.m4_terrorist2, gflag.m4_ambasador)
    
def zoq_fot_pik_ambassador_terrorist_death():
    if tml.GameAction.exist(gflag.m4_terrorist1) or tml.GameAction.exist(gflag.m4_terrorist2):
        return
    gflag.m4_status = MISSION_COMPLETED
    if tml.GameAction.exist(gflag.m4_ambasador):
        dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/zoq-fot-pik.xml"))
        tml.GameAction.remove_location(gflag.m4_ambasador)
    
############################################################################################################
# Mission 5
def capture_precursor_battleship_func():
    gflag.current_mission = """ You must capture precursor wrack  in Ixis star system."""
    gflag.m5_status = MISSION_IN_PROGRESS
    id = tml.EventManager.distanceLessThen(gflag.precursor_wreck_id,
                                            tml.GameAction.get_player_ship_id(),
                                            200,  'capture_precursor_battleship_complete')
    add_druuge_guardians()
    
def add_druuge_guardians():
    id = tml.EventManager.distanceLessThen(gflag.precursor_wreck_id,
                                           tml.GameAction.get_player_ship_id(),
                                           2500,  'druuge_this_is_crimson_corporation_property_now')
    for i in xrange(1):
        enemy = tml.GameAction.add_ship('Ixis',
                                        "druma", 1500, 5000, tml.GameAction.get_enemy_team())
        tml.GameAction.guard_location(enemy, gflag.precursor_wreck_id, 1500)

def druuge_this_is_crimson_corporation_property_now():
    dialog.runDialogFile(tml.GameConfig.GetAbsolutePath("dialogs/druuge.xml"))

def capture_precursor_battleship_complete():
    gflag.m5_status = MISSION_COMPLETED
    win_game_func()
    

def win_game_func():
    tml.GameAction.end_game()
    congrat = []
    congrat.append("""You win this little demo game""")
    congrat.append("")
    congrat.append("Programming:")
    congrat.append("  Yura Semashko (Yurand)")
    congrat.append("")
    congrat.append("Dialogs:")
    congrat.append("  FrungySnack")
    congrat.append("  Halleck")
    congrat.append("  Yura Semashko (Yurand)")
    congrat.append("")
    congrat.append("Art")
    congrat.append("  Tiina Aumala")
    congrat.append("")
    congrat.append("Please, consider help us with TW-Light: Legacies")
    congrat.append("For detail check our site http://tw-light.berlios.de/")
    tml.GameAction.scroll_text(misc.PyListStringToVector(congrat),"images/background.jpg")
    pass

############################################################################################################

