/*
  This file is part of "TW-Light" 
  http://tw-light.berlios.de/
  Copyright (C) 2001-2004  TimeWarp development team

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

#include <allegro.h>
#include <stdio.h>
#include <string.h>

#include "melee.h"

#include "melee/mlog.h"
#include "melee/mcontrol.h"
#include "melee/mframe.h"
#include "melee/mview.h"
#include "melee/mitems.h"
#include "melee/mhelpers.h"

#include "scp.h"
#include "util/history.h"
#include "util/sound.h"

#include "gamehierarchy.h"
#include "ggob.h"

#include <algorithm>

MainGame::MainGame(const std::string& game_path)
{
}

int MainGame::Load(const std::string& save)
{
	return 0;
}

//################################################################################################
//  Intro

void MainGame::intro()
{
  BITMAP* d_buf;
  std::vector<std::string> intro_text;

  intro_text.push_back("The Ur-quan are defeated - the destruction");
  intro_text.push_back("of the Sa-matra threw them into chaos,");
  intro_text.push_back("making them easy prey for");
  intro_text.push_back("the New Alliance of Free Stars.");
  intro_text.push_back("Within weeks the NAFS forces managed");
  intro_text.push_back("to destroy most of the fleets of the two ");
  intro_text.push_back("races who terrorized the galaxy");
  intro_text.push_back("for the past 20,000 years!");
  intro_text.push_back("");
  intro_text.push_back("Thanks to captain Zelnick, hope is given");
  intro_text.push_back("to the entire galaxy, and especially to");
  intro_text.push_back("the human race. Now free from their prison");
  intro_text.push_back("under a Slaveshield it's Humanity's time");
  intro_text.push_back("to rebuild.");
  intro_text.push_back("");
  intro_text.push_back("However, it seems there are more troubles");
  intro_text.push_back("ahead. It is time for great space");
  intro_text.push_back("exploration, colonization and piracy.");
  intro_text.push_back("You have to live in this world,");
  intro_text.push_back("young earth captain!!!");

  d_buf = create_bitmap(SCREEN_W, SCREEN_H);
  clear(d_buf);
  copy_buf();

  tw_sound->play_music(data_full_path("music/intro.xm"), -1);
  clear(d_buf);
  BITMAP* logo = load_bitmap(data_full_path("images/3dlogo.jpg").c_str(), NULL);
  stretch_blit(logo, d_buf, 0, 0, logo->w, logo->h, 0, 0, screen->w, screen->h);
  destroy_bitmap(logo);

  textout_centre(d_buf, D_FONT_ENGLISH, "TimeWarp development team", screen->w/2, screen->h-50, -1);
  copy_buf();
  HAVE_A_WAIT(2500);
 
  clear(d_buf);
  textout_centre(d_buf, D_FONT_ENGLISH, "somewhat proudly", screen->w/2, screen->h/2, -1);
  textout_centre(d_buf, D_FONT_ENGLISH, "present", screen->w/2, screen->h/2+40, -1);
  copy_buf();
  HAVE_A_WAIT(2500);
  clear(d_buf);

  BITMAP* pkunk = load_bitmap(data_full_path("images/PkunkQueen.jpg").c_str(), NULL);
  blit(pkunk, d_buf, 0, 0,  (screen->w-pkunk->w)/2, 20, pkunk->w, pkunk->h);
  textout_centre(d_buf, D_FONT_ENGLISH, "TW-Light : Legacies", screen->w/2, pkunk->h+60, -1);
  destroy_bitmap(pkunk);
  copy_buf();
  HAVE_A_WAIT(2500);
  
  ScrollText(intro_text,  D_FONT_ENGLISH, -1, "images/background.jpg", "c", 2);


  clear(d_buf);
  copy_buf();	
  destroy_bitmap(d_buf);
}

int MainGame::play()
{
	// Show Intro
	RGB tmpPal[256];
	memcpy(tmpPal, palette_color, sizeof(RGB) * 256);
	set_palette((const RGB*)g_game_data[TW_FONT_PALETTE].dat);
      
	intro();
	videosystem->set_palette(tmpPal);
	play_game("GOB", "", NULL);
	
	return 0;
}

