/*
This file is part of "TW-Light" 
                    http://tw-light.berlios.de/
Copyright (C) 2001-2004  TimeWarp development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#ifndef __TW_LIGHT_GAMECONFIG_H__
#define __TW_LIGHT_GAMECONFIG_H__

#include <string>
/// game configuration class
///
/// All game settings should stored here
class GameConfig
{
  static std::string game_data_dir;
 public:
  /// Set directory where game should search for it's data and scripts
  ///
  /// @param gamedir absolute path
  static void SetGameDirectory(const std::string& gamedir);
  
  /// Get directory where game should search for it's data and scripts
  static std::string GetGameDirectory();

  /// Get absolute path to data
  ///
  /// The function first search in Game data directory, then it common data directory
  /// @param file file path
  /// @return absolute path or empty string on errors
  static std::string GetAbsolutePath(const std::string& file);
};

#endif


